#include <stdio.h>
#include <stdlib.h>           /* voor atol() */

/* roteer een getal tussen 0 en 25;
 * het resultaat ligt weer tussen 0 en 25 */
int rot(int i,int afstand)
{
        /* het resultaat is  i+afstand,
         * tenzij dat >= 26 is; dan is het  i+afstand-26 */        
        return i+afstand<26 ? i+afstand : i+afstand-26;
}

int main(int argc, char **argv)
{
        int letter;
        int afstand;

        if (argc != 2) {
                puts("gebruik: caesar <rotatie-afstand>");
                return 10;
        }

        afstand = atol(argv[1]);
        if (afstand<0 || afstand>26) {
                puts("afstand moet tussen 0 en 25 liggen");
        }

        while ((letter = getchar()) != EOF) {
                if (letter>='a' && letter<='z')        /* kleine letter */
                        putchar('a' + rot(letter-'a',afstand));
                else if (letter>='A' && letter<='Z')   /* hoofdletter */
                        putchar('A' + rot(letter-'A',afstand));
                else putchar(letter);                  /* geen letter */
        }
        return 0;
}
