#include <stdio.h>
#include <stdlib.h>

struct persoon {
        struct persoon *link;
        char naam[40];
        char voornaam[20];
};

/* in: lijst  anker van de lijst
 *     nieuw  in te voegen element
 * uit: anker van de nieuwe lijst
 */
struct persoon *voegVooraanToe(struct persoon *lijst,struct persoon *nieuw)
{
        nieuw->link = lijst;
        return nieuw;
}

/* in: anker van de af te drukken lijst */
void drukLijst(struct persoon *lijst)
{
        struct persoon *volg;

        volg = lijst;
        while (volg != NULL) {
                printf("%s %s\n",volg->naam,volg->voornaam);
                volg = volg->link;
        }
}

void freeLijst(struct persoon *lijst)
{
        struct persoon *volg;

        volg = lijst;
        while (volg != NULL) {
                struct persoon *volgende;

                volgende = volg->link;
                free(volg);
                /* op dit punt is volg->link ongeldig!
                 * Daarom heb ik die pointer eerder bewaard in 'volgende'. */
                volg = volgende;
        }
}

int main(void)
{
        struct persoon *lijst;   /* anker */
        struct persoon *ik;

        lijst = NULL;
        ik = malloc(sizeof(struct persoon));
        strcpy(ik->naam,"Vernaeve");
        strcpy(ik->voornaam,"Geert");
        /* merk op dat ik->link niet geinitialiseerd is */
        lijst = voegVooraanToe(lijst,ik);

        ik = malloc(sizeof(struct persoon));
        strcpy(ik->naam,"Ritchie");
        strcpy(ik->voornaam,"Dennis");
        lijst = voegVooraanToe(lijst,ik);

        drukLijst(lijst);

        freeLijst(lijst);

        return 0;
}

