/* maak een string die de inhoud van het getal bevat;
 * bv. maakString(42) geeft de string "42" */
char *maakString(int getal)
{
        char resultaat[20];
        int lengte;

        /* Bijzonder geval. Als we deze regel zouden weglaten,
         * zou het resultaat van maakString(0) een lege string zijn
         */
        if (getal == 0) return "0";

        lengte = 0;

        /* Eerst de string achterstevoren maken
         * (getal%10 geeft het laatste cijfer)
         */
        while (getal != 0) {
                /* We veronderstellen dat de code van '0'
                 * 1 minder is dan '1', 2 minder dan '2' enz.
                 * (dit is het geval in de ASCII codering)
                 */
                resultaat[lengte] = getal%10 + '0';
                getal = getal / 10;
                lengte = lengte + 1;
        }

        /* De string netjes afsluiten met een nulbyte */
        resultaat[lengte] = 0;

        {       /* Resultaat omkeren */
                int tel, telaf;

                tel = 0;
                telaf = lengte-1;
                while (tel < telaf) {
                        /* verwissel resultaat[tel] en resultaat[telaf] */
                        char wissel;

                        wissel = resultaat[tel];
                        resultaat[tel] = resultaat[telaf];
                        resultaat[telaf] = wissel;

                        tel = tel + 1;
                        telaf = telaf - 1;
                }
        }

        return resultaat;
}

